"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function stringifyDeclaration(declaration) {
  var prop = '"' + declaration.property + '":';

  if (_typeof(declaration.value) === 'object') {
    return prop + '{' + declaration.value.map(stringifyDeclaration).join(',\n') + '}';
  }

  return prop + 'props.' + declaration.value;
}

var _default = {
  name: 'react-fela',
  stringify: function stringify(_ref) {
    var style = _ref.style,
        moduleName = _ref.moduleName,
        classNameMap = _ref.classNameMap,
        className = _ref.className;
    var hasVariations = Object.keys(classNameMap).length > 1;
    return "import './" + moduleName + ".elo.css'\n" + "import { createComponent } from 'react-fela'\n" + (hasVariations ? "import { getClassNameFromVariantMap } from '@elodin/runtime'\n\n" + 'const variantMap = ' + JSON.stringify(classNameMap, null, 2) + '\n\n' : '\n') + 'function ' + moduleName + '(props  = {})' + ' {\n  ' + 'return {\n    ' + '_className: ' + (hasVariations ? "getClassNameFromVariantMap('" + className + "', variantMap, props)" : className) + ',\n    ' + style.map(stringifyDeclaration).join(',\n    ') + '\n  }\n}\n\n' + 'export default createComponent(' + moduleName + ')';
  }
};
exports.default = _default;